# coding: utf-8

"""
    Smstools API

    The SMS Gateway API for smstools provides a robust and easy-to-integrate solution for sending and receiving SMS messages programmatically. It enables developers to integrate text messaging capabilities into their applications, websites, and software, offering features such as sending single or bulk SMS, managing contacts and groups, receiving inbound messages, and accessing delivery reports. This API facilitates various communication needs, from marketing campaigns to CRM integrations and automated alerts. Please note that this API description is independently created and not affiliated with smstools.com. Official documentation at: https://www.smstools.com/en/sms-gateway-api/

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from smstools.models.get_history200_response_all_of_messages_inner_response import GetHistory200ResponseAllOfMessagesInnerResponse
from typing import Optional, Set
from typing_extensions import Self

class GetHistory200ResponseAllOfMessagesInner(BaseModel):
    """
    GetHistory200ResponseAllOfMessagesInner
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, alias="ID")
    message_id: Optional[StrictStr] = Field(default=None, alias="message_ID")
    message: Optional[StrictStr] = None
    to: Optional[StrictStr] = None
    sender: Optional[StrictStr] = None
    var_date: Optional[StrictStr] = Field(default=None, alias="date")
    type: Optional[StrictStr] = None
    status: Optional[StrictStr] = None
    response: Optional[GetHistory200ResponseAllOfMessagesInnerResponse] = None
    __properties: ClassVar[List[str]] = ["ID", "message_ID", "message", "to", "sender", "date", "type", "status", "response"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetHistory200ResponseAllOfMessagesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of response
        if self.response:
            _dict['response'] = self.response.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetHistory200ResponseAllOfMessagesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ID": obj.get("ID"),
            "message_ID": obj.get("message_ID"),
            "message": obj.get("message"),
            "to": obj.get("to"),
            "sender": obj.get("sender"),
            "date": obj.get("date"),
            "type": obj.get("type"),
            "status": obj.get("status"),
            "response": GetHistory200ResponseAllOfMessagesInnerResponse.from_dict(obj["response"]) if obj.get("response") is not None else None
        })
        return _obj


