# coding: utf-8

"""
    Smstools API

    The SMS Gateway API for smstools provides a robust and easy-to-integrate solution for sending and receiving SMS messages programmatically. It enables developers to integrate text messaging capabilities into their applications, websites, and software, offering features such as sending single or bulk SMS, managing contacts and groups, receiving inbound messages, and accessing delivery reports. This API facilitates various communication needs, from marketing campaigns to CRM integrations and automated alerts. Please note that this API description is independently created and not affiliated with smstools.com. Official documentation at: https://www.smstools.com/en/sms-gateway-api/

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from smstools.models.whatsapp_send_action_request_all_of_buttons_inner import WhatsappSendActionRequestAllOfButtonsInner
from typing import Optional, Set
from typing_extensions import Self

class WhatsappSendActionRequest(BaseModel):
    """
    WhatsappSendActionRequest
    """ # noqa: E501
    sender: StrictStr = Field(description="The number or name of the sender. A number can't be longer than 14 characters. A name can't be longer than 11 characters and can't contain special characters")
    to: StrictStr = Field(description="the number that will receive the message in international format (eg: 324xx, 316xx, ...)")
    var_date: Optional[StrictStr] = Field(default=None, description="Format: yyyy-MM-dd HH:mm. If not provided, the message will be sent as soon as possible", alias="date")
    reference: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="String of max. 255 characters")
    test: Optional[StrictBool] = Field(default=False, description="The system will check all parameters but will not send an SMS message (no credits/balance used).")
    subid: Optional[StrictStr] = Field(default=None, description="If specified, the message will be sent from the subaccount.")
    buttons: List[WhatsappSendActionRequestAllOfButtonsInner] = Field(description="Provide an array of objects, where each object contains an id and a title. Both id and title are required fields. Please note: Min amount buttons: 1, Max amount buttons: 3")
    header: Optional[StrictStr] = Field(default=None, description="The header of the message displayed in WhatsApp.")
    footer: Optional[StrictStr] = Field(default=None, description="The footer of the message displayed in WhatsApp")
    __properties: ClassVar[List[str]] = ["sender", "to", "date", "reference", "test", "subid", "buttons", "header", "footer"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WhatsappSendActionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in buttons (list)
        _items = []
        if self.buttons:
            for _item_buttons in self.buttons:
                if _item_buttons:
                    _items.append(_item_buttons.to_dict())
            _dict['buttons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WhatsappSendActionRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sender": obj.get("sender"),
            "to": obj.get("to"),
            "date": obj.get("date"),
            "reference": obj.get("reference"),
            "test": obj.get("test") if obj.get("test") is not None else False,
            "subid": obj.get("subid"),
            "buttons": [WhatsappSendActionRequestAllOfButtonsInner.from_dict(_item) for _item in obj["buttons"]] if obj.get("buttons") is not None else None,
            "header": obj.get("header"),
            "footer": obj.get("footer")
        })
        return _obj


